#include "FrequenciesCombo.h"

#include <qfile.h>
#include <qtextstream.h>
#include <qpe/qpeapplication.h> 

FrequenciesCombo::FrequenciesCombo(QWidget * parent=0, const char * name=0)
	: QComboBox(parent, name), isPXA270(false)
{
   QFile fCPU("/proc/cpuinfo");
   if(fCPU.open(IO_ReadOnly))
   {
      QString s;
      fCPU.readLine(s, 100);
      isPXA270 = s.find("PXA270") != -1;
      fCPU.close();
   }
   
   QFile f("/home/zaurus/Settings/freqchange.conf");
   if (f.open(IO_ReadOnly)) 
   {
      QTextStream t(&f);
      QString s;
      while (!t.eof()) 
      {
         s = t.readLine();
         ClockVCore clockvcore;
         bool addItem = false;
         QString title;

         if (s.startsWith("0") || s.startsWith("1"))
         {
            bool ok1, ok2, ok3;
            int sep = s.find(',');
            
            // systype loaded from first element in line
            // denotes a menu item for PXA270 systems if set to 1
            int systype = s.left(sep).toInt(&ok1, 16);
            s = s.right(s.length() - (sep + 1));
            sep = s.find(',');
            title = s.left(sep);
            s = s.right(s.length() - (sep + 1));
            sep = s.find(',');
            clockvcore.clock = s.left(sep).toInt(&ok2, 16);
            s = s.right(s.length() - (sep + 1));
            clockvcore.vcore = s.toInt(&ok3, 16);
   
            // Conditionals added for isPXA270 comparison against
            // system type from config file.
            addItem = ((sep != -1) && (title != "" ) && (ok1 == TRUE) && (ok2 == TRUE) && (ok3 == TRUE) && clockvcore.clock && (((systype == 1) && isPXA270) || ((systype == 0) && !isPXA270)));
         }
         else
         {
            bool ok;
            int sep = s.find(',');
            title = s.left(sep);
            clockvcore.clock = s.right(s.length() - s.find(',') - 1).toInt(&ok, 16);
   
            addItem = ((sep != -1) &&  (title != "") && (ok == TRUE) && clockvcore.clock);
         }

         if (addItem)
         {
            frequencies[title] = clockvcore;
            insertItem(title);
         }
      }
      f.close();
   }

/*    QFile f(QPEApplication::documentDir() + "../Settings/freqchange.conf");
    if (f.open(IO_ReadOnly)) 
    {
        QTextStream t(&f);
        QString s;
        while (!t.eof()) 
        {
            ClockVCore clockvcore;
            s = t.readLine();
			
   			bool ok;
   			int sep = s.find(',');
   			QString title = s.left(sep);
   			clockvcore.clock = s.right(s.length() - s.find(',') - 1).toInt(&ok, 16);
   
   			if ((sep != -1) &&  (title != "") && (ok == TRUE) && clockvcore.clock) 
   			{
   				frequencies[title] = clockvcore;
   				insertItem(title);
   			}
        }
        f.close();
    }
*/}

void FrequenciesCombo::setCurrentFrequency(ClockVCore freq)
{
	for (int i = 0; i < count(); ++i) 
	{
		if (frequencies[text(i)].clock == freq.clock)
		{
			setCurrentItem(i);
			break;
		}
	}
}

ClockVCore FrequenciesCombo::currentFrequency()
{
	return frequencies[currentText()];
}

