/**********************************************************************
 **********************************************************************/


#include "freqchangeapplet.h"

#include <qpe/resource.h>

#include <qpainter.h>
#include <qpopupmenu.h>
#include <qapplication.h>
#include <qstring.h>
#include <qpe/qpeapplication.h>
#include <qcopchannel_qws.h>
#include <qdir.h>
#include <qdict.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qlayout.h>
#include <qmap.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "power.h"
#define CONFIG_FILE_NAME "/home/zaurus/Settings/freqchange_.conf"
//===========================================================================


	FreqChangeApplet::FreqChangeApplet(const PowerStatus2 *ps, QWidget *parent, const char *name )
: QWidget( parent, name ),idFreqMap()
{
	int clocks[][2]={{0x241,0},{0x242,0},{0x161,0}};
	int clocks270[][2]={{0x2000210,0xa},{0x2000214,0xc},{0x2000218,0xe}};
	int clocks_amount=3; 
	isPXA270=false;
	QFile fCPU("/proc/cpuinfo");
  	if(fCPU.open(IO_ReadOnly) ){
    		QString s;
    		fCPU.readLine(s, 100);
    		if (s.find("PXA270") != -1 ){
    		  isPXA270 = true;
    		}
    		fCPU.close();
  	}

	freqchangePixmap = Resource::loadPixmap( "freqchange" );
	QGridLayout *formLayout = new QGridLayout( this, 1, 1, 11, 6, "formLayout"); 
	buttonGroup= new QButtonGroup( this, "Frequency applet" );
	buttonGroup->setColumnLayout(0, Qt::Vertical );
	buttonGroup->layout()->setSpacing( 6 );
	buttonGroup->layout()->setMargin( 11 );
	QVBoxLayout *buttonGroupLayout = new QVBoxLayout( buttonGroup->layout() );
	buttonGroupLayout->setAlignment( Qt::AlignTop );
	battery_cccr=0;
	charging_cccr=0;
	int cpuregister=readClock();
	int menuitem_num=0;
	QFile f_conf(CONFIG_FILE_NAME);
	if (f_conf.open(IO_ReadOnly))
	{
		QTextStream t( &f_conf );
		QString s;
		while ( !t.eof() ) {
			s = t.readLine();

			bool ok;
			int sep = s.find(':');
			QString title = s.left(sep);
			printf(s);
			int clock = s.right(s.length()-s.find(':')-1).toInt(&ok,16);
			if ((sep !=-1) && (title !="") && (ok == TRUE) && clock ) 
			{
				if (title=="Battery") battery_cccr=clock;
				if (title=="Charging") charging_cccr=clock;			
			}


		}
		f_conf.close();
		config_changed=false;
	}else
	{
		config_changed=true;
	}

	if (!battery_cccr) battery_cccr=cpuregister;
	if (!charging_cccr) charging_cccr=cpuregister;

	if (ps->acStatus() == PowerStatus2::Offline)
	{
		charging=false;
		if (battery_cccr!=cpuregister)
		{
			cpuregister=battery_cccr;
			writeClock(cpuregister);
		}
	}else if (ps->acStatus() == PowerStatus2::Online)
	{
		charging=true;
		if (charging_cccr!=cpuregister)
		{
			cpuregister=charging_cccr;
			writeClock(cpuregister);
		}
	}		


	QFile f("/home/zaurus/Settings/freqchange.conf");
	if ( f.open(IO_ReadOnly) ) 
	{
		QTextStream t( &f );
		QString s;
		while ( !t.eof() ) {
			s = t.readLine();

			bool ok1,ok2,ok3;
			int sep = s.find(',');
			// systype loaded from first element in line
			// denotes a menu item for PXA270 systems if set to 1
			int systype = s.left(sep).toInt(&ok1,16);
			s = s.right(s.length()-(sep+1));
			sep = s.find(',');
			QString title = s.left(sep);
			s = s.right(s.length()-(sep+1));
			sep = s.find(',');
			int clock = s.left(sep).toInt(&ok2,16);
			s = s.right(s.length()-(sep+1));
			int vcore = s.toInt(&ok3,16);

			// Conditionals added for isPXA270 comparison against
			// system type from config file.
			if ((sep !=-1) && (title !="") && (ok1 == TRUE) && (ok2 == TRUE) && (ok3 == TRUE) && clock && (((systype == 1) && isPXA270) || ((systype == 0) && !isPXA270))) 
			{
				QRadioButton * radioButton= new QRadioButton( buttonGroup, title );
				radioButton->setText(title);
				buttonGroupLayout->addWidget( radioButton );
				mapStruct tMap;
				tMap.clock=clock; tMap.vcore=vcore;
				idFreqMap.insert(buttonGroup->id( radioButton ),tMap);
				if (clock == cpuregister)
				{
					radioButton->setChecked(TRUE);
				} else 
				{
					radioButton->setChecked( FALSE);
				}
				menuitem_num++;
			};


		}
		f.close();
	}


	if(menuitem_num ==0){
		char *buffer=new char[10];
		for(int i=0;i<clocks_amount;i++)
		{
			mapStruct tMap;
			tMap.clock = isPXA270 ? clocks270[i][0] :  clocks[i][0];
			tMap.vcore = isPXA270 ? clocks270[i][1] :  clocks[i][1];
			sprintf(buffer,"%x",tMap.clock);
			QString direntName=QString(buffer);

			QRadioButton * radioButton= new QRadioButton( buttonGroup, direntName );
			radioButton->setText(direntName);
			buttonGroupLayout->addWidget( radioButton );
			
			idFreqMap.insert(buttonGroup->id( radioButton ),tMap);
			if (tMap.clock == cpuregister)
			{
				radioButton->setChecked(TRUE);
			} else 
			{
				radioButton->setChecked( FALSE);
			}
			menuitem_num++;

		}
		delete buffer;

	}
	
	current_cccr=cpuregister;
	connect(buttonGroup, SIGNAL(pressed(int)), this, SLOT(action(int)));

	formLayout->addWidget( buttonGroup, 0, 0 );
}

int FreqChangeApplet::readClock()const
{

	FILE *fp;
	int cpuregister;
	if (isPXA270) 
		fp=fopen("/proc/zaurus/CCCR", "r");
	else
		fp=fopen("/proc/cccr_change", "r");
	fscanf(fp, "%x", &cpuregister);
	fclose(fp);
	return cpuregister;


}


void FreqChangeApplet::action(int id)
{
	printf("freqChangeApplet id=%d\n",id);
	writeClock(idFreqMap[id]);
	if (charging)
	{
		charging_cccr=idFreqMap[id].clock;
	}else
	{
		battery_cccr=idFreqMap[id].clock;
	}
	
	config_changed=true;
}

void FreqChangeApplet::writeClock(mapStruct map)
{
	FILE *fp;
	sync();
	if (isPXA270)
		fp=fopen("/proc/zaurus/CCCR", "w");
	else
		fp=fopen("/proc/cccr_change", "w");
	fprintf(fp, "%08X\n",map.clock);
	fclose(fp);
	if (isPXA270) {
		fp=fopen("/proc/zaurus/VCORE", "w");
		fprintf(fp, "%02X\n",map.vcore);
		fclose(fp);
	}
}

void FreqChangeApplet::writeClock(int clock)
{
	QMap<int,mapStruct>::Iterator it;
	for ( it = idFreqMap.begin(); it != idFreqMap.end(); ++it ) 
		if (it.data().clock==clock) {
			writeClock(it.data());
			break;
		}
}

void FreqChangeApplet::writeConfig()
{
	FILE *f_conf;
	f_conf=fopen(CONFIG_FILE_NAME, "w");
	fprintf(f_conf, "Battery: %08X\nCharging: %08X",battery_cccr,charging_cccr);
	fclose(f_conf);	
	config_changed=false;
}

void FreqChangeApplet::updateClock(const PowerStatus2 *ps)
{

	int cpuregister=0;
	if ( ps->acStatus() == PowerStatus2::Offline && charging) 
	{
		charging=false;
		cpuregister=battery_cccr;
		writeClock(cpuregister);

	} 
	else if ( ps->acStatus() == PowerStatus2::Online && !charging) 
	{
		charging=true;
		cpuregister=charging_cccr;
		writeClock(cpuregister);
	} 
	else 
	{
		cpuregister=readClock();
		if (charging)
		{
			if (charging_cccr!=cpuregister)
			{
				config_changed=true;
				charging_cccr=cpuregister;
			}
		}else
		{
			if (battery_cccr!=cpuregister)
			{
				config_changed=true;
				battery_cccr=cpuregister;
			}
		}
	}

	if (current_cccr!=cpuregister)
	{	
		QMap<int,mapStruct>::Iterator it;
		for ( it = idFreqMap.begin(); it != idFreqMap.end(); ++it ) 
			if (cpuregister==it.data().clock)
				((QRadioButton*)(buttonGroup->find(it.key())))->setChecked(TRUE);
		current_cccr=cpuregister;
	}
	if (config_changed) writeConfig();
}

