/**********************************************************************
**********************************************************************/

#ifndef __FREQCHANGE_APPLET_H__
#define __FREQCHANGE_APPLET_H__

#include <qwidget.h>
#include <qpixmap.h>
#include <qmap.h>

typedef struct { int clock; int vcore; } mapStruct;

class QButtonGroup;
class PowerStatus2;
class FreqChangeApplet : public QWidget
{
    Q_OBJECT
public:
    FreqChangeApplet(const PowerStatus2 *ps, QWidget *parent = 0, const char *name=0 );
    void updateClock(const PowerStatus2 *ps);

private:
    int readClock()const;
    void writeClock(mapStruct);
    void writeClock(int clock);
    void writeConfig();
	
private slots:
    void action(int);

private:
//    QPopupMenu* menu;

	QButtonGroup *buttonGroup;
	QPixmap freqchangePixmap;
	QMap<int,mapStruct> idFreqMap;
	int nFreqMapCount;
	int charging_cccr;
	int battery_cccr;
	bool charging;
	int current_cccr;
	bool config_changed;
	
	bool isPXA270;
};


#endif // __FREQCHANGE_APPLET_H__
