#ifndef _KINOSETTINGS_H_
#define _KINOSETTINGS_H_

#include <qvariant.h>
#include <qdialog.h>
#include <qcstring.h>
#include <qstringlist.h>
#include <qlineedit.h>
#include <qwhatsthis.h>
#include <qmap.h>

#include "kinosettingsbase.h"
#include "FrequenciesCombo.h"

class KinoPrefs {
public:
	//Playback
	bool		f_normal;
	bool		f_repeat;
	bool		f_random;

	bool		f_cpu;

	ClockVCore		s_v_cpu;
	ClockVCore		s_a_cpu;

	int		s_priority;
   bool     f_suspend;
   bool     f_lid_suspend;

	QString 	s_mplayeroptions;
	bool		f_debug;
	QString 	s_types;

	QString 	s_url_history;
	QString 	s_history;

    // Media Stream
    bool		f_cache;
    int		s_cache;
    int		s_bandwidth;

    // Video
    bool		f_dropframes;
    bool		f_directrendering;
    bool		f_doublebuffer;
    bool		f_smart_crop;
    bool		f_rotate;
    bool    f_softscale;
    bool		f_osd_rotate;
    bool		f_index;
    bool		f_external_mem;
    bool		f_noaspect;
    bool		f_osd;

    // Audio
    bool		f_resample;
	 bool		f_lcd_off;
	 bool		f_sdl;
	 bool		f_fade;
    bool    f_swvolume;
    int     s_maxvolume;
    int     s_volstep;
    bool    f_tracking;
    bool    f_autosync;
    bool    f_hrseek;

	 // Playlist
	 bool		f_playonclick;
	 bool		f_saveplaylist;
    bool    f_playlist_pos;
    bool    f_file_pos;

	 bool		f_addontap;
    QString	s_enc_mp3;
    QString	s_enc_playlist;
    QString s_font;
    int     s_fontSize;

	// Controls
	bool		f_remote;
	bool		f_lid;
   bool     f_keyboard;
	bool		f_release;

   typedef QMap<int, int> ActionsMap;
	ActionsMap keyboardActions, remoteActions;
};

class KinoSettings : public KinoSettingsBase
{
    Q_OBJECT

public:
    KinoSettings( QWidget* parent = 0, const QString &name = "", bool modal = FALSE, WFlags fl = 0 );
    ~KinoSettings();

    void setSettings(KinoPrefs p);
    KinoPrefs getSettings(void);

protected slots:
    void cacheToggled(bool);
    void cpuToggled(bool);
};

#endif
